@if (formGroup && field) {
  <ng-container [formGroup]="formGroup">
    <div>
      @switch (field.rendering.inputType.name) {
        @case (TypeName.dropdown_list) {
          <sqtm-core-select-field
            [formGroup]="formGroup"
            [fieldName]="field.id"
            [options]="displayOptions"
            [showSearch]="filterPossibleValues"
          >
          </sqtm-core-select-field>
        }
        @case (TypeName.text_field) {
          <sqtm-app-remote-autocomplete-text-field
            [placeholder]="fieldPlaceHolder"
            [formGroup]="formGroup"
            [field]="field"
            [hasFocus]="hasFocus"
            [attr.data-test-field-id]="field.id"
          >
          </sqtm-app-remote-autocomplete-text-field>
        }
        @case (TypeName.unknown) {
          <sqtm-app-remote-autocomplete-text-field
            [formGroup]="formGroup"
            [field]="field"
          >
          </sqtm-app-remote-autocomplete-text-field>
        }
        @case (TypeName.date_picker) {
          <sqtm-core-date-picker [formGroup]="formGroup" [fieldName]="field.id">
          </sqtm-core-date-picker>
        }
        @case (TypeName.date_time) {
          <sqtm-core-date-picker
            [showTime]="true"
            [formGroup]="formGroup"
            [fieldName]="field.id"
          >
          </sqtm-core-date-picker>
        }
        @case (TypeName.text_area) {
          <sqtm-core-text-area-field
            [formGroup]="formGroup"
            [fieldName]="field.id"
            [rows]="8"
          >
          </sqtm-core-text-area-field>
        }
        @case (TypeName.tag_list) {
          <sqtm-app-remote-command-tag-field
            [formGroup]="formGroup"
            [fieldName]="field.id"
            [field]="field"
            [options]="displayOptions"
          >
          </sqtm-app-remote-command-tag-field>
        }
        @case (TypeName.free_tag_list) {
          <sqtm-app-remote-command-tag-field
            [formGroup]="formGroup"
            [fieldName]="field.id"
            [field]="field"
            [options]="displayOptions"
          >
          </sqtm-app-remote-command-tag-field>
        }
        @case (TypeName.radio_button) {
          <sqtm-core-radio-select-field
            [formGroup]="formGroup"
            [fieldName]="field.id"
            [options]="displayOptions"
          >
          </sqtm-core-radio-select-field>
        }
        @case (TypeName.option_with_child) {
          <sqtm-core-cascading-select-field
            [options]="cascadingSelectOptions"
            [formControl]="getFormControl(field)"
            [attr.data-test-field-name]="field.id"
          >
          </sqtm-core-cascading-select-field>
        }
        @case (TypeName.cascading_select) {
          <sqtm-core-cascading-select-field
            [options]="cascadingSelectOptions"
            [formControl]="getFormControl(field)"
            [attr.data-test-field-name]="field.id"
          >
          </sqtm-core-cascading-select-field>
        }
        @case (TypeName.checkbox_list) {
          <sqtm-core-checkbox-group-field
            [options]="checkboxOptions"
            [formControl]="getFormControl(field)"
            [attr.data-test-field-name]="field.id"
          >
          </sqtm-core-checkbox-group-field>
        }
        @case (TypeName.multi_select) {
          <sqtm-app-remote-command-tag-field
            [formGroup]="formGroup"
            [fieldName]="field.id"
            [field]="field"
            [options]="displayOptions"
          >
          </sqtm-app-remote-command-tag-field>
        }
        @case (TypeName.file_upload) {
          <sqtm-app-remote-attachment-field
            [attr.data-test-field-name]="field.id"
          >
          </sqtm-app-remote-attachment-field>
        }
        @case (TypeName.checkbox) {
          <label
            nz-checkbox
            ngDefaultControl
            [formGroup]="formGroup"
            [formControlName]="field.id"
            [attr.data-test-field-name]="field.id"
          >
          </label>
        }
        @case (TypeName.combo_box) {
          <sqtm-app-remote-combo-box-field
            [formGroup]="formGroup"
            [field]="field"
            [options]="displayOptions"
            [attr.data-test-field-name]="field.id"
          >
          </sqtm-app-remote-combo-box-field>
        }
        @case (TypeName.tree_select) {
          <nz-tree-select
            class="full-width"
            [nzDefaultExpandAll]="true"
            [formGroup]="formGroup"
            [formControlName]="field.id"
            [nzNodes]="nzNodes"
            [nzAllowClear]="false"
          >
          </nz-tree-select>
        }
        @case (TypeName.rich_text) {
          <sqtm-core-rich-text-field
            [formGroup]="formGroup"
            [fieldName]="field.id"
          >
          </sqtm-core-rich-text-field>
        }
        @case (TypeName.integer) {
          <sqtm-core-numeric-field
            [formGroup]="formGroup"
            [fieldName]="field.id"
            [step]="1"
            [precision]="0"
          >
          </sqtm-core-numeric-field>
        }
        @case (TypeName.decimal) {
          <sqtm-core-numeric-field
            [formGroup]="formGroup"
            [fieldName]="field.id"
          >
          </sqtm-core-numeric-field>
        }
        @case (TypeName.selector_field) {
          <sqtm-app-remote-selector-field
            [placeholder]="fieldPlaceHolder"
            [selectorField]="field"
            [formGroup]="formGroup"
            [attr.data-test-field-name]="field.id"
          >
          </sqtm-app-remote-selector-field>
        }
        @default {
          <span>-</span>
        }
      }
    </div>
  </ng-container>
}
